Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -4131,408 +4185,320 @@
 
 
-                flux_t = w(k,j,i) * rho_air_zw(k) * (                         &
-                           ( 37.0_wp * ibit8 * adv_sca_5                      &
-                        +     7.0_wp * ibit7 * adv_sca_3                      &
-                        +           ibit6 * adv_sca_1                         &
-                           ) *                                                &
-                                   ( sk(k+1,j,i)  + sk(k,j,i)    )            &
-                    -      (  8.0_wp * ibit8 * adv_sca_5                      &
-                        +              ibit7 * adv_sca_3                      &
-                           ) *                                                &
-                                   ( sk(k_pp,j,i) + sk(k-1,j,i)  )            &
-                    +      (           ibit8 * adv_sca_5                      &
-                           ) *     ( sk(k_ppp,j,i)+ sk(k_mm,j,i) )            &
-                                       )
-
-                diss_t = -ABS( w(k,j,i) ) * rho_air_zw(k) * (                 &
-                           ( 10.0_wp * ibit8 * adv_sca_5                      &
-                        +     3.0_wp * ibit7 * adv_sca_3                      &
-                        +              ibit6 * adv_sca_1                      &
-                           ) *                                                &
-                                   ( sk(k+1,j,i)   - sk(k,j,i)    )           &
-                    -      (  5.0_wp * ibit8 * adv_sca_5                      &
-                        +              ibit7 * adv_sca_3                      &
-                           ) *                                                &
-                                   ( sk(k_pp,j,i)  - sk(k-1,j,i)  )           &
-                    +      (           ibit8 * adv_sca_5                      &
-                           ) *                                                &
-                                   ( sk(k_ppp,j,i) - sk(k_mm,j,i) )           &
-                                               )
-!
-!--             Calculate the divergence of the velocity field. A respective
-!--             correction is needed to overcome numerical instabilities caused
-!--             by a not sufficient reduction of divergences near topography.
-                div   =   ( u(k,j,i+1) * ( ibit0 + ibit1 + ibit2 )             &
-                          - u(k,j,i)   * (                                     &
-                        REAL( IBITS(advc_flag(k,j,i-1),0,1), KIND = wp )       &
-                      + REAL( IBITS(advc_flag(k,j,i-1),1,1), KIND = wp )       &
-                      + REAL( IBITS(advc_flag(k,j,i-1),2,1), KIND = wp )       &
-                                         )                                     &
-                          ) * ddx                                              &
-                        + ( v(k,j+1,i) * ( ibit3 + ibit4 + ibit5 )             &
-                          - v(k,j,i)   * (                                     &
-                        REAL( IBITS(advc_flag(k,j-1,i),3,1), KIND = wp )       &
-                      + REAL( IBITS(advc_flag(k,j-1,i),4,1), KIND = wp )       &
-                      + REAL( IBITS(advc_flag(k,j-1,i),5,1), KIND = wp )       &
-                                         )                                     &
-                          ) * ddy                                              &
-                        + ( w(k,j,i) * rho_air_zw(k) *                         &
-                                         ( ibit6 + ibit7 + ibit8 )             &
-                          - w(k-1,j,i) * rho_air_zw(k-1) *                     &
-                                         (                                     &
-                        REAL( IBITS(advc_flag(k-1,j,i),6,1), KIND = wp )       &
-                      + REAL( IBITS(advc_flag(k-1,j,i),7,1), KIND = wp )       &
-                      + REAL( IBITS(advc_flag(k-1,j,i),8,1), KIND = wp )       &
-                                         )                                     &      
-                          ) * drho_air(k) * ddzw(k)
-
-
-                tend(k,j,i) = tend(k,j,i) - (                                 &
-                        ( ( flux_r + diss_r )                                 &
-                      -   ( flux_l + diss_l ) ) * ddx                         &
-                      + ( ( flux_n + diss_n )                                 &
-                      -   ( flux_s + diss_s ) ) * ddy                         &
-                      + ( ( flux_t + diss_t )                                 &
-                      -   ( flux_d + diss_d ) ) * drho_air(k) * ddzw(k)       &
-                                            ) + sk(k,j,i) * div
-
-#ifndef _OPENACC
-                swap_flux_y_local(k)   = flux_n
-                swap_diss_y_local(k)   = diss_n
-                swap_flux_x_local(k,j) = flux_r
-                swap_diss_x_local(k,j) = diss_r
-#endif
-                flux_d                 = flux_t
-                diss_d                 = diss_t
-
-!
-!--             Evaluation of statistics. 
-                SELECT CASE ( sk_num )
-
-                    CASE ( 1 )
-                       !$ACC ATOMIC
-                       sums_wspts_ws_l(k,tn) = sums_wspts_ws_l(k,tn)           &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 2 )
-                       !$ACC ATOMIC
-                       sums_wssas_ws_l(k,tn) = sums_wssas_ws_l(k,tn)           &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 3 )
-                       !$ACC ATOMIC
-                       sums_wsqs_ws_l(k,tn)  = sums_wsqs_ws_l(k,tn)            &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 4 )
-                       !$ACC ATOMIC
-                       sums_wsqcs_ws_l(k,tn)  = sums_wsqcs_ws_l(k,tn)          &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 5 )
-                       !$ACC ATOMIC
-                       sums_wsqrs_ws_l(k,tn)  = sums_wsqrs_ws_l(k,tn)          &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 6 )
-                       !$ACC ATOMIC
-                       sums_wsncs_ws_l(k,tn)  = sums_wsncs_ws_l(k,tn)          &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 7 )
-                       !$ACC ATOMIC
-                       sums_wsnrs_ws_l(k,tn)  = sums_wsnrs_ws_l(k,tn)          &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 8 )
-                       !$ACC ATOMIC
-                       sums_wsss_ws_l(k,tn)  = sums_wsss_ws_l(k,tn)            &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 9 )
-                        !$ACC ATOMIC
-                        sums_salsa_ws_l(k,tn)  = sums_salsa_ws_l(k,tn)         &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-
-                END SELECT
-
+                flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                       &
+                           ( 37.0_wp * ibit8 * adv_sca_5                       &
+                        +     7.0_wp * ibit7 * adv_sca_3                       &
+                        +              ibit6 * adv_sca_1                       &
+                           ) *                                                 &
+                                   ( sk(k+1,j,i)  + sk(k,j,i)    )             &
+                    -      (  8.0_wp * ibit8 * adv_sca_5                       &
+                        +              ibit7 * adv_sca_3                       &
+                           ) *                                                 &
+                                   ( sk(k_pp,j,i) + sk(k-1,j,i)  )             &
+                    +      (           ibit8 * adv_sca_5                       &
+                           ) *     ( sk(k_ppp,j,i)+ sk(k_mm,j,i) )             &
+                                                       )
+
+                diss_t(k) = -ABS( w(k,j,i) ) * rho_air_zw(k) * (               &
+                           ( 10.0_wp * ibit8 * adv_sca_5                       &
+                        +     3.0_wp * ibit7 * adv_sca_3                       &
+                        +              ibit6 * adv_sca_1                       &
+                           ) *                                                 &
+                                   ( sk(k+1,j,i)   - sk(k,j,i)    )            &
+                    -      (  5.0_wp * ibit8 * adv_sca_5                       &
+                        +              ibit7 * adv_sca_3                       &
+                           ) *                                                 &
+                                   ( sk(k_pp,j,i)  - sk(k-1,j,i)  )            &
+                    +      (           ibit8 * adv_sca_5                       &
+                           ) *                                                 &
+                                   ( sk(k_ppp,j,i) - sk(k_mm,j,i) )            &
+                                                               )
              ENDDO
 
-             DO  k = nzb_max_l+1, nzt
-
-                u_comp = u(k,j,i+1) - u_gtrans + u_stokes_zu(k)
-                flux_r = u_comp * (                                           &
-                      37.0_wp * ( sk(k,j,i+1) + sk(k,j,i)   )                 &
-                    -  8.0_wp * ( sk(k,j,i+2) + sk(k,j,i-1) )                 &
-                    +           ( sk(k,j,i+3) + sk(k,j,i-2) ) ) * adv_sca_5
-                diss_r = -ABS( u_comp ) * (                                   &
-                      10.0_wp * ( sk(k,j,i+1) - sk(k,j,i)   )                 &
-                    -  5.0_wp * ( sk(k,j,i+2) - sk(k,j,i-1) )                 &
-                    +           ( sk(k,j,i+3) - sk(k,j,i-2) ) ) * adv_sca_5
-
-#ifdef _OPENACC
-!
-!--             Recompute the left fluxes.
-                u_comp_l = u(k,j,i) - u_gtrans + u_stokes_zu(k)
-                flux_l = u_comp_l * (                                         &
-                                      37.0_wp * ( sk(k,j,i)   + sk(k,j,i-1) ) &
-                                    -  8.0_wp * ( sk(k,j,i+1) + sk(k,j,i-2) ) &
-                                    +           ( sk(k,j,i+2) + sk(k,j,i-3) ) &
-                                               ) * adv_sca_5
-
-                diss_l = -ABS( u_comp_l ) * (                                 &
-                                      10.0_wp * ( sk(k,j,i)   - sk(k,j,i-1) ) &
-                                    -  5.0_wp * ( sk(k,j,i+1) - sk(k,j,i-2) ) &
-                                    +           ( sk(k,j,i+2) - sk(k,j,i-3) ) &
-                                                       ) * adv_sca_5
-#else
-                flux_l = swap_flux_x_local(k,j)
-                diss_l = swap_diss_x_local(k,j)
-#endif
-
-                v_comp = v(k,j+1,i) - v_gtrans + v_stokes_zu(k)
-                flux_n = v_comp * (                                           &
-                      37.0_wp * ( sk(k,j+1,i) + sk(k,j,i)   )                 &
-                    -  8.0_wp * ( sk(k,j+2,i) + sk(k,j-1,i) )                 &
-                    +           ( sk(k,j+3,i) + sk(k,j-2,i) ) ) * adv_sca_5
-                diss_n = -ABS( v_comp ) * (                                   &
-                      10.0_wp * ( sk(k,j+1,i) - sk(k,j,i)   )                 &
-                    -  5.0_wp * ( sk(k,j+2,i) - sk(k,j-1,i) )                 &
-                    +           ( sk(k,j+3,i) - sk(k,j-2,i) ) ) * adv_sca_5
-
-#ifdef _OPENACC
-!
-!--             Recompute the south fluxes.
-                v_comp_s = v(k,j,i) - v_gtrans + v_stokes_zu(k)
-                flux_s = v_comp_s * (                                        &
-                                    37.0_wp * ( sk(k,j,i)   + sk(k,j-1,i) )  &
-                                  -  8.0_wp * ( sk(k,j+1,i) + sk(k,j-2,i) )  &
-                                  +           ( sk(k,j+2,i) + sk(k,j-3,i) )  &
-                                             ) * adv_sca_5
-                diss_s = -ABS( v_comp_s ) * (                                &
-                                    10.0_wp * ( sk(k,j,i)   - sk(k,j-1,i) )  &
-                                  -  5.0_wp * ( sk(k,j+1,i) - sk(k,j-2,i) )  &
-                                  +             sk(k,j+2,i) - sk(k,j-3,i)    &
-                                                      ) * adv_sca_5
-#else
-                flux_s = swap_flux_y_local(k)
-                diss_s = swap_diss_y_local(k)
-#endif
-
-!
-!--             k index has to be modified near bottom and top, else array
-!--             subscripts will be exceeded.
+             DO  k = nzb+2, nzt-2
                 ibit8 = REAL( IBITS(advc_flag(k,j,i),8,1), KIND = wp )
                 ibit7 = REAL( IBITS(advc_flag(k,j,i),7,1), KIND = wp )
                 ibit6 = REAL( IBITS(advc_flag(k,j,i),6,1), KIND = wp )
 
+                flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                       &
+                           ( 37.0_wp * ibit8 * adv_sca_5                       &
+                        +     7.0_wp * ibit7 * adv_sca_3                       &
+                        +              ibit6 * adv_sca_1                       &
+                           ) *                                                 &
+                                   ( sk(k+1,j,i)  + sk(k,j,i)    )             &
+                    -      (  8.0_wp * ibit8 * adv_sca_5                       &
+                        +              ibit7 * adv_sca_3                       &
+                           ) *                                                 &
+                                   ( sk(k+2,j,i) + sk(k-1,j,i)  )              &
+                    +      (           ibit8 * adv_sca_5                       &
+                           ) *     ( sk(k+3,j,i)+ sk(k-2,j,i) )                &
+                                                       )
+
+                diss_t(k) = -ABS( w(k,j,i) ) * rho_air_zw(k) * (               &
+                           ( 10.0_wp * ibit8 * adv_sca_5                       &
+                        +     3.0_wp * ibit7 * adv_sca_3                       &
+                        +              ibit6 * adv_sca_1                       &
+                           ) *                                                 &
+                                   ( sk(k+1,j,i)   - sk(k,j,i)    )            &
+                    -      (  5.0_wp * ibit8 * adv_sca_5                       &
+                        +              ibit7 * adv_sca_3                       &
+                           ) *                                                 &
+                                   ( sk(k+2,j,i)  - sk(k-1,j,i)  )             &
+                    +      (           ibit8 * adv_sca_5                       &
+                           ) *                                                 &
+                                   ( sk(k+3,j,i) - sk(k-2,j,i) )               &
+                                                               )
+             ENDDO
+
+             DO  k = nzt-1, nzt-symmetry_flag
+                ibit8 = REAL( IBITS(advc_flag(k,j,i),8,1), KIND = wp )
+                ibit7 = REAL( IBITS(advc_flag(k,j,i),7,1), KIND = wp )
+                ibit6 = REAL( IBITS(advc_flag(k,j,i),6,1), KIND = wp )
+!
+!--             k index has to be modified near bottom and top, else array
+!--             subscripts will be exceeded.
                 k_ppp = k + 3 * ibit8
                 k_pp  = k + 2 * ( 1 - ibit6  )
                 k_mm  = k - 2 * ibit8
 
-
-                flux_t = w(k,j,i) * rho_air_zw(k) * (                         &
-                           ( 37.0_wp * ibit8 * adv_sca_5                      &
-                        +     7.0_wp * ibit7 * adv_sca_3                      &
-                        +              ibit6 * adv_sca_1                      &
-                           ) *                                                &
-                                   ( sk(k+1,j,i)  + sk(k,j,i)     )           &
-                    -      (  8.0_wp * ibit8 * adv_sca_5                      &
-                        +              ibit7 * adv_sca_3                      &
-                           ) *                                                &
-                                   ( sk(k_pp,j,i) + sk(k-1,j,i)   )           &
-                    +      (           ibit8 * adv_sca_5                      &
-                           ) *     ( sk(k_ppp,j,i)+ sk(k_mm,j,i)  )           &
-                                       )
-
-                diss_t = -ABS( w(k,j,i) ) * rho_air_zw(k) * (                 &
-                           ( 10.0_wp * ibit8 * adv_sca_5                      &
-                        +     3.0_wp * ibit7 * adv_sca_3                      &
-                        +              ibit6 * adv_sca_1                      &
-                           ) *                                                &
-                                   ( sk(k+1,j,i)   - sk(k,j,i)    )           &
-                    -      (  5.0_wp * ibit8 * adv_sca_5                      &
-                        +              ibit7 * adv_sca_3                      &
-                           ) *                                                &
-                                   ( sk(k_pp,j,i)  - sk(k-1,j,i)  )           &
-                    +      (           ibit8 * adv_sca_5                      &
-                           ) *                                                &
-                                   ( sk(k_ppp,j,i) - sk(k_mm,j,i) )           &
-                                               )
+                flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                       &
+                           ( 37.0_wp * ibit8 * adv_sca_5                       &
+                        +     7.0_wp * ibit7 * adv_sca_3                       &
+                        +              ibit6 * adv_sca_1                       &
+                           ) *                                                 &
+                                   ( sk(k+1,j,i)  + sk(k,j,i)    )             &
+                    -      (  8.0_wp * ibit8 * adv_sca_5                       &
+                        +              ibit7 * adv_sca_3                       &
+                           ) *                                                 &
+                                   ( sk(k_pp,j,i) + sk(k-1,j,i)  )             &
+                    +      (           ibit8 * adv_sca_5                       &
+                           ) *     ( sk(k_ppp,j,i)+ sk(k_mm,j,i) )             &
+                                                       )
+
+                diss_t(k) = -ABS( w(k,j,i) ) * rho_air_zw(k) * (               &
+                           ( 10.0_wp * ibit8 * adv_sca_5                       &
+                        +     3.0_wp * ibit7 * adv_sca_3                       &
+                        +              ibit6 * adv_sca_1                       &
+                           ) *                                                 &
+                                   ( sk(k+1,j,i)   - sk(k,j,i)    )            &
+                    -      (  5.0_wp * ibit8 * adv_sca_5                       &
+                        +              ibit7 * adv_sca_3                       &
+                           ) *                                                 &
+                                   ( sk(k_pp,j,i)  - sk(k-1,j,i)  )            &
+                    +      (           ibit8 * adv_sca_5                       &
+                           ) *                                                 &
+                                   ( sk(k_ppp,j,i) - sk(k_mm,j,i) )            &
+                                                               )
+             ENDDO
+
+!
+!--          Set resolved/turbulent flux at model top to zero (w-level). In case that
+!--          a symmetric behavior between bottom and top shall be guaranteed (closed
+!--          channel flow), the flux at nzt is also set to zero.
+             IF ( symmetry_flag == 1 ) THEN
+                flux_t(nzt) = 0.0_wp
+                diss_t(nzt) = 0.0_wp
+             ENDIF
+             flux_t(nzt+1) = 0.0_wp
+             diss_t(nzt+1) = 0.0_wp
+
+             DO  k = nzb+1, nzb_max_l
+
+                flux_d    = flux_t(k-1)
+                diss_d    = diss_t(k-1)
+
+                ibit2 = REAL( IBITS(advc_flag(k,j,i),2,1), KIND = wp )
+                ibit1 = REAL( IBITS(advc_flag(k,j,i),1,1), KIND = wp )
+                ibit0 = REAL( IBITS(advc_flag(k,j,i),0,1), KIND = wp )
+
+                ibit5 = REAL( IBITS(advc_flag(k,j,i),5,1), KIND = wp )
+                ibit4 = REAL( IBITS(advc_flag(k,j,i),4,1), KIND = wp )
+                ibit3 = REAL( IBITS(advc_flag(k,j,i),3,1), KIND = wp )
+
+                ibit8 = REAL( IBITS(advc_flag(k,j,i),8,1), KIND = wp )
+                ibit7 = REAL( IBITS(advc_flag(k,j,i),7,1), KIND = wp )
+                ibit6 = REAL( IBITS(advc_flag(k,j,i),6,1), KIND = wp )
 !
 !--             Calculate the divergence of the velocity field. A respective
 !--             correction is needed to overcome numerical instabilities introduced
 !--             by a not sufficient reduction of divergences near topography.
-                div         =   ( u(k,j,i+1) - u(k,j,i)   ) * ddx              &
-                              + ( v(k,j+1,i) - v(k,j,i)   ) * ddy              &
-                              + ( w(k,j,i)   * rho_air_zw(k) -                 &
-                                  w(k-1,j,i) * rho_air_zw(k-1)                 &
+                div         =   ( u(k,j,i+1) * ( ibit0 + ibit1 + ibit2 )       &
+                                - u(k,j,i)   * (                               &
+                              REAL( IBITS(advc_flag(k,j,i-1),0,1), KIND = wp ) &
+                            + REAL( IBITS(advc_flag(k,j,i-1),1,1), KIND = wp ) &
+                            + REAL( IBITS(advc_flag(k,j,i-1),2,1), KIND = wp ) &
+                                               )                               &
+                                ) * ddx                                        &
+                              + ( v(k,j+1,i) * ( ibit3 + ibit4 + ibit5 )       &
+                                - v(k,j,i)   * (                               &
+                              REAL( IBITS(advc_flag(k,j-1,i),3,1), KIND = wp ) &
+                            + REAL( IBITS(advc_flag(k,j-1,i),4,1), KIND = wp ) &
+                            + REAL( IBITS(advc_flag(k,j-1,i),5,1), KIND = wp ) &
+                                               )                               &
+                                ) * ddy                                        &
+                              + ( w(k,j,i) * rho_air_zw(k) *                   &
+                                               ( ibit6 + ibit7 + ibit8 )       &
+                                - w(k-1,j,i) * rho_air_zw(k-1) *               &
+                                               (                               &
+                              REAL( IBITS(advc_flag(k-1,j,i),6,1), KIND = wp ) &
+                            + REAL( IBITS(advc_flag(k-1,j,i),7,1), KIND = wp ) &
+                            + REAL( IBITS(advc_flag(k-1,j,i),8,1), KIND = wp ) &
+                                               )                               &
                                 ) * drho_air(k) * ddzw(k)
 
-                tend(k,j,i) = tend(k,j,i) - (                                 &
-                        ( ( flux_r + diss_r )                                 &
-                      -   ( flux_l + diss_l ) ) * ddx                         &
-                      + ( ( flux_n + diss_n )                                 &
-                      -   ( flux_s + diss_s ) ) * ddy                         &
-                      + ( ( flux_t + diss_t )                                 &
-                      -   ( flux_d + diss_d ) ) * drho_air(k) * ddzw(k)       &
+                tend(k,j,i) = tend(k,j,i) - (                                  &
+                         ( flux_r(k) + diss_r(k) - swap_flux_x_local(k,j,tn) - &
+                           swap_diss_x_local(k,j,tn)            ) * ddx        &
+                       + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k,tn)   - &
+                           swap_diss_y_local(k,tn)              ) * ddy        &
+                       + ( ( flux_t(k) + diss_t(k) ) -                         &
+                           ( flux_d    + diss_d    )                           &
+                                                                )              &
+                          * drho_air(k) * ddzw(k) &
                                             ) + sk(k,j,i) * div
 
 #ifndef _OPENACC
-                swap_flux_y_local(k)   = flux_n
-                swap_diss_y_local(k)   = diss_n
-                swap_flux_x_local(k,j) = flux_r
-                swap_diss_x_local(k,j) = diss_r
+                swap_flux_y_local(k,tn)   = flux_n(k)
+                swap_diss_y_local(k,tn)   = diss_n(k)
+                swap_flux_x_local(k,j,tn) = flux_r(k)
+                swap_diss_x_local(k,j,tn) = diss_r(k)
 #endif
-                flux_d                 = flux_t
-                diss_d                 = diss_t
-
-!
-!--             Evaluation of statistics. 
-                SELECT CASE ( sk_num )
-
-                    CASE ( 1 )
+
+             ENDDO
+
+             DO  k = nzb_max_l+1, nzt
+
+                flux_d    = flux_t(k-1)
+                diss_d    = diss_t(k-1)
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities introduced
+!--             by a not sufficient reduction of divergences near topography.
+                div         =   ( u(k,j,i+1) - u(k,j,i) ) * ddx                &
+                              + ( v(k,j+1,i) - v(k,j,i) ) * ddy                &
+                              + ( w(k,j,i) * rho_air_zw(k)                     &
+                                - w(k-1,j,i) * rho_air_zw(k-1)                 &
+                                                        ) * drho_air(k) * ddzw(k)
+
+                tend(k,j,i) = tend(k,j,i) - (                                  &
+                         ( flux_r(k) + diss_r(k) - swap_flux_x_local(k,j,tn) - &
+                           swap_diss_x_local(k,j,tn)            ) * ddx        &
+                       + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k,tn)   - &
+                           swap_diss_y_local(k,tn)              ) * ddy        &
+                       + ( ( flux_t(k) + diss_t(k) ) -                         &
+                           ( flux_d    + diss_d    )            )              &
+                           * drho_air(k) * ddzw(k)                             &
+                                            ) + sk(k,j,i) * div
+
+#ifndef _OPENACC
+                swap_flux_y_local(k,tn)   = flux_n(k)
+                swap_diss_y_local(k,tn)   = diss_n(k)
+                swap_flux_x_local(k,j,tn) = flux_r(k)
+                swap_diss_x_local(k,j,tn) = diss_r(k)
+#endif
+            ENDDO
+
+!
+!--         Evaluation of statistics.
+            DO  k = nzb+1, nzt
+               SELECT CASE ( sk_num )
+
+                   CASE ( 1 )
+                      !$ACC ATOMIC
+                      sums_wspts_ws_l(k,tn) = sums_wspts_ws_l(k,tn)            &
+                         + ( flux_t(k)                                         &
+                               / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )   &
+                               * ( w(k,j,i) - hom(k,1,3,0)                 )   &
+                           + diss_t(k)                                         &
+                               / ( ABS(w(k,j,i)) + 1.0E-20_wp              )   &
+                               *   ABS(w(k,j,i) - hom(k,1,3,0)             )   &
+                           ) * weight_substep(intermediate_timestep_count)
+                   CASE ( 2 )
+                      !$ACC ATOMIC
+                      sums_wssas_ws_l(k,tn) = sums_wssas_ws_l(k,tn)            &
+                         + ( flux_t(k)                                         &
+                               / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )   &
+                               * ( w(k,j,i) - hom(k,1,3,0)                 )   &
+                           + diss_t(k)                                         &
+                               / ( ABS(w(k,j,i)) + 1.0E-20_wp              )   &
+                               *   ABS(w(k,j,i) - hom(k,1,3,0)             )   &
+                           ) * weight_substep(intermediate_timestep_count)
+                   CASE ( 3 )
+                      !$ACC ATOMIC
+                      sums_wsqs_ws_l(k,tn)  = sums_wsqs_ws_l(k,tn)             &
+                         + ( flux_t(k)                                         &
+                               / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )   &
+                               * ( w(k,j,i) - hom(k,1,3,0)                 )   &
+                           + diss_t(k)                                         &
+                               / ( ABS(w(k,j,i)) + 1.0E-20_wp              )   &
+                               *   ABS(w(k,j,i) - hom(k,1,3,0)             )   &
+                           ) * weight_substep(intermediate_timestep_count)
+                   CASE ( 4 )
+                      !$ACC ATOMIC
+                      sums_wsqcs_ws_l(k,tn)  = sums_wsqcs_ws_l(k,tn)           &
+                         + ( flux_t(k)                                         &
+                               / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )   &
+                               * ( w(k,j,i) - hom(k,1,3,0)                 )   &
+                           + diss_t(k)                                         &
+                               / ( ABS(w(k,j,i)) + 1.0E-20_wp              )   &
+                               *   ABS(w(k,j,i) - hom(k,1,3,0)             )   &
+                           ) * weight_substep(intermediate_timestep_count)
+                   CASE ( 5 )
+                      !$ACC ATOMIC
+                      sums_wsqrs_ws_l(k,tn)  = sums_wsqrs_ws_l(k,tn)           &
+                         + ( flux_t(k)                                         &
+                               / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )   &
+                               * ( w(k,j,i) - hom(k,1,3,0)                 )   &
+                           + diss_t(k)                                         &
+                               / ( ABS(w(k,j,i)) + 1.0E-20_wp              )   &
+                               *   ABS(w(k,j,i) - hom(k,1,3,0)             )   &
+                           ) * weight_substep(intermediate_timestep_count)
+                   CASE ( 6 )
+                      !$ACC ATOMIC
+                      sums_wsncs_ws_l(k,tn)  = sums_wsncs_ws_l(k,tn)           &
+                         + ( flux_t(k)                                         &
+                               / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )   &
+                               * ( w(k,j,i) - hom(k,1,3,0)                 )   &
+                           + diss_t(k)                                         &
+                               / ( ABS(w(k,j,i)) + 1.0E-20_wp              )   &
+                               *   ABS(w(k,j,i) - hom(k,1,3,0)             )   &
+                           ) * weight_substep(intermediate_timestep_count)
+                   CASE ( 7 )
+                      !$ACC ATOMIC
+                      sums_wsnrs_ws_l(k,tn)  = sums_wsnrs_ws_l(k,tn)           &
+                         + ( flux_t(k)                                         &
+                               / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )   &
+                               * ( w(k,j,i) - hom(k,1,3,0)                 )   &
+                           + diss_t(k)                                         &
+                               / ( ABS(w(k,j,i)) + 1.0E-20_wp              )   &
+                               *   ABS(w(k,j,i) - hom(k,1,3,0)             )   &
+                           ) * weight_substep(intermediate_timestep_count)
+                   CASE ( 8 )
+                      !$ACC ATOMIC
+                      sums_wsss_ws_l(k,tn)  = sums_wsss_ws_l(k,tn)             &
+                         + ( flux_t(k)                                         &
+                               / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )   &
+                               * ( w(k,j,i) - hom(k,1,3,0)                 )   &
+                           + diss_t(k)                                         &
+                               / ( ABS(w(k,j,i)) + 1.0E-20_wp              )   &
+                               *   ABS(w(k,j,i) - hom(k,1,3,0)             )   &
+                           ) * weight_substep(intermediate_timestep_count)
+                   CASE ( 9 )
                        !$ACC ATOMIC
-                       sums_wspts_ws_l(k,tn) = sums_wspts_ws_l(k,tn)           &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 2 )
-                       !$ACC ATOMIC
-                       sums_wssas_ws_l(k,tn) = sums_wssas_ws_l(k,tn)           &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 3 )
-                       !$ACC ATOMIC
-                       sums_wsqs_ws_l(k,tn)  = sums_wsqs_ws_l(k,tn)            &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 4 )
-                       !$ACC ATOMIC
-                       sums_wsqcs_ws_l(k,tn)  = sums_wsqcs_ws_l(k,tn)          &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 5 )
-                       !$ACC ATOMIC
-                       sums_wsqrs_ws_l(k,tn)  = sums_wsqrs_ws_l(k,tn)          &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 6 )
-                       !$ACC ATOMIC
-                       sums_wsncs_ws_l(k,tn)  = sums_wsncs_ws_l(k,tn)          &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 7 )
-                       !$ACC ATOMIC
-                       sums_wsnrs_ws_l(k,tn)  = sums_wsnrs_ws_l(k,tn)          &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 8 )
-                       !$ACC ATOMIC
-                       sums_wsss_ws_l(k,tn)  = sums_wsss_ws_l(k,tn)            &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
-                    CASE ( 9 )
-                        !$ACC ATOMIC
-                        sums_salsa_ws_l(k,tn)  = sums_salsa_ws_l(k,tn)         &
-                          + ( flux_t                                           &
-                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
-                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t                                           &
-                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
-                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
-                            ) * weight_substep(intermediate_timestep_count)
+                       sums_salsa_ws_l(k,tn)  = sums_salsa_ws_l(k,tn)          &
+                         + ( flux_t(k)                                         &
+                               / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )   &
+                               * ( w(k,j,i) - hom(k,1,3,0)                 )   &
+                           + diss_t(k)                                         &
+                               / ( ABS(w(k,j,i)) + 1.0E-20_wp              )   &
+                               *   ABS(w(k,j,i) - hom(k,1,3,0)             )   &
+                           ) * weight_substep(intermediate_timestep_count)
 
                 END SELECT
 
              ENDDO
-
-         ENDDO
-      ENDDO
+          ENDDO
+       ENDDO
+
+       CALL cpu_log( log_point_s(49), 'advec_s_ws', 'stop' )
 
     END SUBROUTINE advec_s_ws
